<?php
/**
 * A proxy to coub service
 *
 * It fetches the content from the service and injects style file in the header.
 */

if ( ! isset( $_GET['url'] ) ) {
	exit( 0 );
}

// CHANGE this, with your own stylesheet.
$stylesheet_url = "http://example.com/somestyle.css";


$url = trim( $_GET['url'] );

// we only serve the coub.com urls.
if ( strpos( $url, 'https://coub.com/embed/' ) !== 0 ) {
	exit( 0 );
}

$defaults = array(
	'width'         => 450,
	'height'        => 360,
	// Yes, we are using 'true/false strings and not booleans as th service expects strings.
	'hideTopBar'    => 'true',
	'noSiteButtons' => 'true',
	'noHDControl'   => 'true',
	'muted'         => 'false',
	'autostart'     => 'false',
	'originalSize'  => 'true',
	'startWithHD'   => 'true',
);

$params = array();
foreach ( $defaults as $key => $value ) {

	if ( ! empty( $_GET[ $key ] ) ) {
		$value = $_GET[ $key ];
	}

	$params[ $key ] = $value;
}

$url = $url .'?'. http_build_query( $params );

$contents = file_get_contents( $url );
// unable to access the service, there was a problem.
if ( false === $contents ) {
	exit( 0 );
}

// Inject our css.
// We can inject as we wish.
$search_code  = '</head>';
$replace_code = '<link rel="stylesheet" type="text/css" href="' . $stylesheet_url . '" /></head>';
// if we are here, append our stylesheet.
$contents = str_replace( $search_code, $replace_code, $contents );
echo $contents;

exit;
